/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package ca.mcscert.jtet.expression;

/**
 *
 * @author matthew
 */
public class Variable implements Expression, ExpressionValue {
    public Variable(String name, VariableType type) {
        m_outputName = m_name = name;
        m_type = type;
    }

    public String name() {
        return m_name;
    }

    public VariableType type() {
        return m_type;
    }

    public String outputName()
    {
        return m_outputName;
    }

    /* This changes the variable as outputed by a CheckerGenerator.
     *
     * There are times when a user wants to rename a variable used in an Expression.  However, it would be weird to change
     * the actual name, as then the VariableCollection would be weird.  Instead, use a special output name, that is used
     * when generating code but is otherwise the same.
     */
    public void setOutputName(String outputName)
    {
        this.m_outputName = outputName;
    }

    @Override
    public VariableType actualOutputTypeForRequestedOutput(VariableTypeMarker requestedType) {
        if (requestedType.isMarkerFor(m_type)) {
            return m_type;
        }
        return null;
    }

    final private String m_name;
    private String m_outputName;
    final private VariableType m_type;

    @Override
    public String getCheckerOutput(CheckerGenerator generator, VariableType requestedType) {
        if (!type().equals(requestedType)) {
            throw new IllegalArgumentException("Requested output type is not the expression's output type!");
        }
        return m_outputName;
    }

    @Override
    public String toString() {
        return m_name;
    }
}
