lexer grammar VariableParserLexer;

tokens { ID }

fragment IDRule: [a-zA-Z][a-zA-Z0-9_]*; //Variable identifier.  Start with letter, then alpha numerical allowed with underscores.

REGULAR_ID: IDRule -> type(ID), pushMode(VARIABLE_TYPE);

fragment WS : [ \t\r\n]+; // skip spaces, tabs, newlines
WS1: WS -> skip ;


mode PVS_EXPR_MODE;
PVS_EXPR: ~[\{\}]+ -> popMode;


mode VARIABLE_TYPE;
VAR_SEPARATOR: ',' -> popMode;
COLON: ':';
BOOL_TYPE: 'bool';
REAL_TYPE: 'real';
FIXEDT: 'fixedt' -> pushMode(FIXED_TYPE);
UNKNOWN_TYPE: [a-zA-Z_]+;

OPEN_SUBTYPE: '{' -> pushMode(ID_FETCH);
PVS_EXPR_BEGIN: '|' -> pushMode(PVS_EXPR_MODE);
CLOSE_SUBTYPE: '}';

WS2: WS -> skip;

mode FIXED_TYPE;
NAT_SEPARATOR: ',';
OPEN_BRACKET: '(';
CLOSE_BRACKET: ')' -> popMode;
NAT: [0-9]+;

WS3: WS -> skip;


mode ID_FETCH;
SUBTYPE_ID: IDRule -> type(ID), popMode;

WS4: WS -> skip;
